package ;
import enemies.EnemyManager;
import enemies.Mole;
import flash.geom.Point;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.group.FlxGroup;
import flixel.tile.FlxTilemap;
import ice.entity.GameObjectManager;
import openfl.Assets;
import player.Player;

/**
 * ...
 * @author 
 */
class MapParser
{
	static var enemy:EnemyManager;
	
	public function new() 
	{
		
	}
	
	public static function ParseMap(mapS : String)
	{
		var mapString = mapS;
		mapString = TMXCleanup.RemoveXml(mapString);
		var map = new FlxTilemap();
		map.loadMap(mapString, Assets.getBitmapData("assets/images/Tiles.png"), 32, 32, 0, 1);
		map.setTileProperties(36, FlxObject.NONE);
		map.setTileProperties(52, FlxObject.NONE);
		map.setTileProperties(28, FlxObject.NONE);
		map.setTileProperties(34, FlxObject.NONE);
		map.setTileProperties(35, FlxObject.NONE);
		map.setTileProperties(43, FlxObject.NONE);
		map.setTileProperties(42, FlxObject.NONE);
		map.setTileProperties(5, FlxObject.NONE);
		map.setTileProperties(6, FlxObject.NONE);
		map.setTileProperties(13, FlxObject.NONE);
		map.setTileProperties(14, FlxObject.NONE);
		map.setTileProperties(21, FlxObject.NONE);
		map.setTileProperties(22, FlxObject.NONE);
		map.setTileProperties(30, FlxObject.NONE);
		map.setTileProperties(29, FlxObject.NONE);
		map.setTileProperties(37, FlxObject.NONE);
		map.setTileProperties(38, FlxObject.NONE);
		map.setTileProperties(45, FlxObject.NONE);
		map.setTileProperties(46, FlxObject.NONE);
		map.setTileProperties(60, FlxObject.NONE);
		
		map.pixelPerfectRender = true; //fixes lines on screen
		
		FlxG.worldBounds.width = map.width;
		FlxG.worldBounds.height = map.height;
		
		GameObjectManager.getInstance().AddGameObject(map);
		
		mapS = RemoveMapData(mapS);
		
		ParseEnemies(mapS);
		
		ParsePlayer(mapS);
	}
	
	static function RemoveMapData(map : String) : String
	{
		var start = map.indexOf("<data");
		var end = map.indexOf("</data>") + 7;
		var newMap = map.substring(0, start);
		newMap += map.substring(end, map.length);
		return newMap;
	}
	
	static private function ParseEnemies(mapS : String):Void 
	{
		var enemyGroup = new FlxGroup();
		
		enemy = new EnemyManager();
		
		var enemies:Xml = Xml.parse(mapS);
		enemies = enemies.firstElement();
		for (e in enemies.elementsNamed("objectgroup"))
		{
			if (e.get("name") == "enemies")
			{
				for (o in e.elements())
				{
					var enemy:Mole = new Mole(new Point(Std.parseInt(o.get("x")), Std.parseInt(o.get("y"))));
					enemyGroup.add(enemy);
				}
			}
		}
		
		GameObjectManager.getInstance().AddGameObject(enemyGroup, "enemies");
	}
	
	static private function ParsePlayer(mapS : String):Void 
	{	
		var player:Player;
		var playerXML:Xml = Xml.parse(mapS);
		playerXML = playerXML.firstElement();
		for (p in playerXML.elementsNamed("objectgroup"))
		{
			if (p.get("name") == "player")
			{
				for (play in p.elements())
				{
					player = new Player(new Point(Std.parseInt(play.get("x")),Std.parseInt(play.get("y"))));
					player.pixelPerfectRender = true;	
					GameObjectManager.getInstance().AddGameObject(player);
				}
			}
		}
	}
	
}