package;

import enemies.EnemyManager;
import enemies.Mole;
import flash.display.BlendMode;
import flash.geom.Point;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.group.FlxGroup;
import flixel.text.FlxText;
import flixel.tile.FlxTilemap;
import flixel.ui.FlxButton;
import flixel.util.FlxColor;
import flixel.util.FlxMath;
import flixel.util.FlxSpriteUtil;
import ice.entity.GameObject;
import ice.entity.GameObjectManager;
import openfl.Assets;
import player.Player;

/**
 * A FlxState which can be used for the actual gameplay.
 */
class PlayState extends FlxState
{
	var darkness:GameObject;
	/**
	 * Function that is called up when to state is created to set it up. 
	 */
	override public function create():Void
	{	
		var back:FlxTilemap = new FlxTilemap();
		back.loadMap(TMXCleanup.RemoveXml(Assets.getText("assets/data/Back.tmx")), Assets.getBitmapData("assets/images/Tiles.png"), 32, 32, 0, 1);
		back.scrollFactor.x = back.scrollFactor.y = 0.5;
		add(back);
		
		add(GameObjectManager.getInstance());
		
		MapParser.ParseMap(Assets.getText("assets/data/Map.tmx"));
		
		darkness = new GameObject("dark");
		darkness.makeGraphic(384, 288, FlxColor.BLACK);
		darkness.scrollFactor.x = 0;
		darkness.scrollFactor.y = 0;
		darkness.blend = BlendMode.MULTIPLY;
		//GameObjectManager.getInstance().AddGameObject(darkness);
		
		super.create();
	}
	
	/**
	 * Function that is called when this state is destroyed - you might want to 
	 * consider setting all objects this state uses to null to help garbage collection.
	 */
	override public function destroy():Void
	{
		super.destroy();
	}
	
	static public function Reset()
	{
		cast(GameObjectManager.getInstance().GetGameObjectByTag("player"),Player).Reset();
		var enemies:FlxGroup = GameObjectManager.getInstance().GetGroup("enemies");
		for (e in enemies)
		{
			cast(e, Mole).Reset();
		}
	}

	/**
	 * Function that is called once every frame.
	 */
	override public function update():Void
	{
		super.update();
	}	
	
	override public function draw():Void 
	{
		FlxSpriteUtil.fill(darkness, 0xFF000000);
		super.draw();
	}
}