package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.input.gamepad.FlxGamepad;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxMath;
import ice.entity.GameObjectManager;
import openfl.Assets;

/**
 * A FlxState which can be used for the game's menu.
 */
class WinState extends FlxState
{
	/**
	 * Function that is called up when to state is created to set it up. 
	 */
	override public function create():Void
	{
		super.create();
		
		//add(GameObjectManager.getInstance());
		
		var title:FlxSprite = new FlxSprite();
		title.loadGraphic(Assets.getBitmapData("assets/images/Win.png"), false, false, 384, 288);
		add(title);
	}
	
	/**
	 * Function that is called when this state is destroyed - you might want to 
	 * consider setting all objects this state uses to null to help garbage collection.
	 */
	override public function destroy():Void
	{
		super.destroy();
	}

	/**
	 * Function that is called once every frame.
	 */
	override public function update():Void
	{
		var gamepad:FlxGamepad = FlxG.gamepads.lastActive;
		
		if (FlxG.keys.justPressed.ANY)
		{
			FlxG.switchState(new PlayState());
		}
		else if (gamepad != null)
		{
			if (gamepad.anyButton())
			{
				FlxG.switchState(new PlayState());
			}
		}
		super.update();
	}	
}