package enemies;
import flixel.animation.FlxAnimation;
import flixel.FlxG;
import flixel.FlxObject;
import ice.entity.Component;
import ice.entity.GameObjectManager;
import player.Player;

/**
 * ...
 * @author 
 */
class MoleLogic extends Component
{
	var movespeed:Float = 50;
	
	var player:Player;
	
	var hiding:Bool = true;
	
	public var flip:Bool = false;
	
	public function new(Owner:Int) 
	{
		super(Owner);
	}
	
	override private function init() 
	{
		super.init();
		
		owner.facing = FlxObject.RIGHT;
		
		player = cast GameObjectManager.getInstance().GetGameObjectByTag("player");
	}
	
	override public function Update() 
	{
		super.Update();
			
		FlxG.collide(owner, GameObjectManager.map);
		
		if (flip) //HACKETYHACKETYHACKKKKKK
		{
			if (owner.facing == FlxObject.LEFT)
			{
				owner.facing = FlxObject.RIGHT;
			}
			else if (owner.facing == FlxObject.RIGHT)
			{
				owner.facing = FlxObject.LEFT;
			}
			flip = false;
		}
		
		owner.velocity.y += Reg.gravity * FlxG.elapsed;
		
		if (hiding)
		{
			if (owner.isTouching(FlxObject.FLOOR) && owner.GetDistance(owner, player) < 150)
			{
				if (player.x < owner.x)
				{
					owner.facing = FlxObject.LEFT;
				}
				else
				{
					owner.facing = FlxObject.RIGHT;
				}
				hiding = false;
				owner.animation.play("popout");
			}
		}
		else if(owner.animation.curAnim == null || owner.animation.curAnim.name != "popout")
		{
			if (owner.isTouching(FlxObject.WALL))
			{
				if (owner.facing == FlxObject.LEFT)
				{
					owner.facing = FlxObject.RIGHT;
				}
				else if (owner.facing == FlxObject.RIGHT)
				{
					owner.facing = FlxObject.LEFT;
				}
			}
			
			if (owner.facing == FlxObject.RIGHT && owner.isTouching(FlxObject.FLOOR))
			{
				owner.velocity.x = movespeed;
				owner.animation.play("shuffle");
			}
			else if(owner.facing == FlxObject.LEFT && owner.isTouching(FlxObject.FLOOR))
			{
				owner.velocity.x = -movespeed;
				owner.animation.play("shuffle");
			}
			if (owner.isTouching(FlxObject.FLOOR) && owner.GetDistance(owner, player) > 200)
			{
				owner.animation.play("burrow");
				hiding = true;
				owner.velocity.x = owner.velocity.y = 0;
			}
		}
	}
}