package player;
import flash.display.BlendMode;
import flash.display.CapsStyle;
import flash.geom.Point;
import flixel.FlxObject;
import flixel.FlxSprite;
import flixel.util.FlxColor;
import flixel.util.FlxSpriteUtil;
import ice.entity.GameObject;
import flixel.FlxG;
import flixel.FlxCamera;
import ice.entity.GameObjectManager;
import openfl.Assets;

/**
 * ...
 * @author 
 */
class Player extends GameObject
{
	var lamp:FlxSprite;
	var dark:GameObject;
	var startPos:Point;
	
	public function new(Pos:Point) 
	{
		super("player", Pos);
		
		startPos = Pos;
		
		loadGraphic(Assets.getBitmapData("assets/images/Player.png"), true, true, 32, 32);
		
		width = 14;
		height = 28;
		offset.y = 4;
		offset.x = 8;
		
		animation.add("idle", [0, 1], 2, true);
		animation.add("walk", [2, 3, 4], 3, true);
		animation.add("run", [5, 6, 7], 6, true);
		animation.add("fall", [8, 9], 4, true);
		animation.add("jump", [10], 1, false);
		animation.add("die", [11, 12, 13], 7, false);
		animation.add("win", [14, 15, 16, 17, 18, 19], 7, false);
		
		AddComponent(new PlayerLogic(GID));
		
		FlxG.camera.follow(this, FlxCamera.STYLE_TOPDOWN_TIGHT, null, 10);
		
				
		lamp = new FlxSprite();
		lamp.loadGraphic(Assets.getBitmapData("assets/images/Lamp.png"));
		lamp.scrollFactor.x = lamp.scrollFactor.y = 0;
	}
	
	override private function init() 
	{
		dark = GameObjectManager.getInstance().GetGameObjectByTag("dark");
		super.init();
	}
	
	public function Reset()
	{
		alive = true;
		setPosition(startPos.x, startPos.y);
		velocity.x = 0;
		velocity.y = 0;
	}
	
	override public function draw():Void 
	{
		/*var pos = getScreenXY();
		if (dark != null)
		{
			dark.stamp(lamp, Std.int(pos.x - lamp._halfWidth + _halfWidth), Std.int(pos.y - lamp._halfHeight + _halfHeight));
		}*/
		super.draw();
	}
}